<?php

function ca_active() { 
	if (file_exists($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caCert.pem"))
		 return TRUE; else return FALSE;
	}
function list_cert($filename) {
	$ca_string = exec("/usr/bin/openssl x509 -in " .  $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . " -noout -subject");
	return str_replace("/", ", ", $ca_string);
	}

function remove_passphrase($filename_lock, $filename_unlock) {
	if( (file_exists($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename_lock)) &&
	  (!file_exists($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename_unlock)) ) 
		system("/usr/bin/openssl rsa -passin pass:foobar -passout pass:foobar -in " . $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename_lock . " -out " . $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename_unlock);
}

function generate_hostkey($filename,$common_name,$ca_country, $ca_state, $ca_city, $ca_orgname, $email) {
	// all form variable checks have been done
	if(file_exists($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.pem")) {
		echo "Error, file already exists!"; exit;
	}
	$expect_file = $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/expect.script";
	$expect_handle = fopen($expect_file ,"w");
	$expect_script = "#!/usr/bin/expect -f\n\nspawn /usr/bin/openssl req -newkey rsa:1024 -keyout /var/www/html/admin/data/" . $filename . "Key.pem.locked -out /var/www/html/admin/data/" . $filename . "Req.pem -passin pass:foobar -passout pass:foobar\n" .
		"expect \"Country Name\"\nsend \"$ca_country\\n\"\n" .
		"expect \"State or\"\nsend \"$ca_state\\n\"\n" .
		"expect \"Locality Name\"\nsend \"$ca_city\\n\"\n" .
		"expect \"Organization Name\"\nsend \"$ca_orgname\\n\"\n" .
		// "expect \"Organizational Unit Name\"\nsend \"WaveSEC Point\\n\"\n" .
		"expect \"Organizational Unit Name\"\nsend \".\\n\"\n" .
		"expect \"Common Name\"\nsend \"$common_name\\n\"\n" .
		"expect \"Email Address\"\nsend \"$email\\n\"\n" .
		"expect \"challenge password\"\nsend \"\\n\"\n" .
		"expect \"optional company name\"\nsend \"\\n\"\n" .
		"expect \"all software sucks, dont remove this line \"\nsend \"$email\\n\"\n" .
		"interact\n\n" ;
	
	fwrite($expect_handle, $expect_script);
	fclose($expect_handle);
	chmod ($expect_file,0755); 
	// for debug use: 
	// echo "<PRE>\n";  system ($expect_file); echo "/<PRE>\n";
	exec ($expect_file);
	// unlink ($expect_file);
	if(!filesize($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Req.pem") > 0) {
		echo "generation of Host IPsec KEY  failed!!\n";
		exit;
	} 
	
	// sign it right away
	$signcmd = "/usr/bin/openssl ca -in " .  $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Req.pem -days 730 -out " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.pem -passin pass:foobar -notext -cert " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caCert.pem -keyfile " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caKey.pem.locked";
	$expect_file = $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/expect.script";
	$expect_handle = fopen($expect_file ,"w");
	$expect_script = "#!/usr/bin/expect -f\n\nspawn " . $signcmd . "\n" .
		"expect \"Sign the certificate?\"\nsend \"y\\n\"\n" .
		"expect \"certificate requests certified, commit\"\nsend \"y\\n\"\n" .
		"expect \"all software sucks, dont remove this line \"\nsend \"nothing\\n\"\n" .
		"interact\n\n" ;
	fwrite($expect_handle, $expect_script);
	fclose($expect_handle);
	chdir($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/");
	chmod($expect_file, 0755);
	// for debug use: 
	echo "<PRE>\n";  system ($expect_file); echo "/<PRE>\n";
	//exec ("$expect_file");
	// unlink ($expect_file);
	if(!filesize($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.pem") > 0) {
		echo "signing of Host IPsec KEY  failed!!\n";
		exit;
	}
	// make .p12 file of it
	$p12cmd = "/usr/bin/openssl pkcs12 -export -inkey " . $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Key.pem.locked -in " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.pem -name \"wavesec\" -certfile " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caCert.pem -caname \"WaveSEC CA\" -out " .
		$GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.p12 -passin pass:foobar -passout pass:foobar";
	// for debug use: 
	// echo "<PRE>\n";  system ($p12cmd); echo "/<PRE>\n";
	exec ($p12cmd);
	// unlink ($expect_file);
	if(!filesize($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/" . $filename . "Cert.p12") > 0) {
		echo "creation pf .p12 file for Host IPsec KEY  failed!!\n";
		exit;
	}
               

}


function generate_ca($ca_country, $ca_state, $ca_city, $ca_orgname, $ca_gateway, $email) {
	// all form variable checks have been done
	$expect_file = $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/expect.script";
	$expect_handle = fopen($expect_file ,"w");
	$expect_script = "#!/usr/bin/expect -f\n\nspawn /usr/bin/openssl req -x509 -days 1460 -newkey rsa:1024 -keyout /var/www/html/admin/data/caKey.pem.locked -out /var/www/html/admin/data/caCert.pem -passin pass:foobar -passout pass:foobar\n" .
	"expect \"Country Name\"\nsend \"$ca_country\\n\"\n" .
	"expect \"State or\"\nsend \"$ca_state\\n\"\n" .
	"expect \"Locality Name\"\nsend \"$ca_city\\n\"\n" .
	"expect \"Organization Name\"\nsend \"$ca_orgname\\n\"\n" .
	//"expect \"Organizational Unit Name\"\nsend \"WaveSEC Point\\n\"\n" .
	"expect \"Organizational Unit Name\"\nsend \".\\n\"\n" .
	"expect \"Common Name\"\nsend \"WaveSEC CA\\n\"\n" .
	"expect \"Email Address\"\nsend \"$email\\n\"\n" .
	"expect \"God all of this really sucks, do not delete this line\"\nsend \"$email\\n\"\n" .
	"interact\n\n" ;
	
	fwrite($expect_handle, $expect_script);
	fclose($expect_handle);
	chmod ($expect_file,0755); 
	// for debug use: 
	//echo "<PRE>\n";  system ($expect_file); echo "/<PRE>\n";
	exec ($expect_file);
	unlink ($expect_file);
	if(!filesize($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caKey.pem.locked") > 0) {
		echo "generation of CA failed!!\n";
		exit;
	}
	remove_passphrase($GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caKey.pem.locked", $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/caKey.pem");
	// /var/www/html/admin/data needs to be put in openssl.cnf, or some other openssl.cnf that is specified
	touch("/var/www/html/admin/data/index.txt");
	$fp = fopen("/var/www/html/admin/data/serial","w");
	fwrite($fp,"01\n");
	fclose($fp);
	mkdir("/var/www/html/admin/data/newcerts", 0755);
	
}
	
function show_certfile($filename) {
	if (!file_exists($filename)) $filename = $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/$filename";
	return system("openssl x509 -in $filename");
}

function print_header(){
	// fuck php include('$GLOBALS['DOCUMENT_ROOT']/wavesec.inc');
	return readfile('/var/www/html/header.inc');
	}
function print_footer(){
	// fuck php include('$GLOBALS['DOCUMENT_ROOT']/wavesec.inc');
	return readfile('/var/www/html/footer.inc');
	}
function invalid_input($field) {
        $test = ereg_replace("[^A-Za-z0-9.]", "", $field);
        if( strlen($test) != strlen($field) ) return TRUE;
        else return FALSE;
}
function invalid_email($field) {
        $test = ereg_replace("[^A-Za-z0-9.@]", "", $field);
        if( strlen($test) != strlen($field) ) return TRUE;
        else return FALSE;
}

function valid_input($field) { return ! invalid_input($field); }
function valid_email($field) { return ! invalid_email($field); }

function list_interfaces() {

	//broken
	$foo = `cat /proc/net/dev|egrep -v 'ipsec|lo:|multicast|Receive'| sed "s/:.*//"|sed "s/ //g"`;
	$arr = explode($foo,"\n");
	return $arr;
}

function check_and_go_secure() {

        $host = $GLOBALS["HTTP_HOST"];
        $port = $GLOBALS["SERVER_PORT"];
        if($port==80) {
                Header("Location: https://$host/$PHP_SELF");
        	exit;
        }
}

function myleftip() {
	 return $GLOBALS["SERVER_ADDR"]; 
}

function generate_client_key() {

        include( $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/ca_vars.inc");
        $serialfile = file(  $GLOBALS['DOCUMENT_ROOT'] . "/admin/data/serial");
        $serial = $serialfile[0];
        $serial = ereg_replace("[^0-9]","",$serial);
        $clientname = "client" . $serial;
        generate_hostkey($clientname,$clientname,$ca_country, $ca_state, $ca_city, $ca_orgname, $email);
	return $clientname . "Cert";
}



?>
